/* * **************************************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Harald Holzmann <harald@varioous.at>, varioous OG
 *
 *  Eyepin For Wordpress is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  any later version.
 *   
 *  Eyepin For Wordpress is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Eyepin For Wordpress. If not, see http://www.gnu.org/copyleft/gpl.html.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************************************** */

jQuery(document).ready(function () {

	if (jQuery('#eyepin-for-wp-textarea').length) {
		var editor = CodeMirror(function (elt) {
			document.getElementById('eyepin-for-wp-textarea').parentNode.replaceChild(elt, document.getElementById('eyepin-for-wp-textarea'));
		}, {
			value: document.getElementById('eyepin-for-wp-textarea').value,
			mode: "text/html"
		});

		editor.on('change', function (cMirror) {
			document.getElementById('eypepin-for-wp-form-fields-holder').value = cMirror.getValue();
		});
	}

	jQuery('#eyepin-for-wp-tab-fields').on('click', function (e) {
		jQuery('#eyepin-for-wp-tabdiv-fields').show();
		jQuery('#eyepin-for-wp-tabdiv-messages').hide();

		jQuery('#eyepin-for-wp-tab-fields').addClass('nav-tab-active');
		jQuery('#eyepin-for-wp-tab-messages').removeClass('nav-tab-active');

		e.preventDefault();
	});

	jQuery('#eyepin-for-wp-tab-messages').on('click', function (e) {
		jQuery('#eyepin-for-wp-tabdiv-messages').show();
		jQuery('#eyepin-for-wp-tabdiv-fields').hide();

		jQuery('#eyepin-for-wp-tab-fields').removeClass('nav-tab-active');
		jQuery('#eyepin-for-wp-tab-messages').addClass('nav-tab-active');

		e.preventDefault();
	});

	for (i = 1; i <= 20; i++) {
		if (jQuery('#eyepin-for-wp-form-tag-add-' + i).length) {
			jQuery('#eyepin-for-wp-form-tag-add-' + i).click((function (value) {
				return function () {
					//get all values from formular
					var className = jQuery('input[name="field-class-' + value + '"]').val();
					var idName = jQuery('input[name="field-id-' + value + '"]').val();
					var label = jQuery('input[name="field-label-' + value + '"]').val();
					var placeholder = jQuery('input[name="field-placeholder-' + value + '"]').val();
					var type = jQuery('input[name="field-type-' + value + '"]').val();
					var defaultValue = jQuery('input[name="field-default-' + value + '"]').val();
					var attributeValue = jQuery('#attribute-select-value option:selected').val();
					var salutationDefaultValue = jQuery('#salutation-select-default-value option:selected').val();

					var htmlType = 'text';
					if (type === 'email') {
						htmlType = 'email';
					} else if (type === 'internet') {
						htmlType = 'url';
					} else if (type === 'phone') {
						htmlType = 'tel';
					} else if (type === 'mobile') {
						htmlType = 'tel';
					}

					//build text to insert into textarea
					var insertcode = "\n<fieldset>";

					if (label.length >= 1) {
						insertcode += "\n\t<label";
						if (idName.length >= 1) {
							insertcode += " for=\"" + idName + "\"";
						}
						if (jQuery('input[name="field-required-' + value + '"]').is(":checked")) {
							label += " *";
						}
						insertcode += ">" + label + "</label>";
					}

					if (type === 'salutation') {
						insertcode += "\n\t<select name=\"" + type + "\"";
					} else if (type === 'attribute') {
						insertcode += "\n\t<input type=\"text\" name=\"" + attributeValue + "\"";
					} else {
						insertcode += "\n\t<input type=\"" + htmlType + "\" name=\"" + type + "\"";
					}

					if (type !== 'salutation') {
						if (placeholder.length >= 1) {
							insertcode += " placeholder=\"" + placeholder + "\"";
						}
					}

					if (className.length >= 1) {
						insertcode += " class=\"" + className + "\"";
					}

					if (idName.length >= 1) {
						insertcode += " id=\"" + idName + "\"";
					}

					if (type !== 'salutation') {
						if (defaultValue.length >= 1) {
							insertcode += " value=\"" + defaultValue + "\"";
						}
					}


					if (jQuery('input[name="field-required-' + value + '"]').is(":checked")) {
						insertcode += " required";
					}

					insertcode += ">";

					if (type === 'salutation') {
						if (salutationDefaultValue === 'female') {
							insertcode += "\n\t\t<option selected=\"selected\" value=\"female\">Weiblich</option>";
						} else {
							insertcode += "\n\t\t<option value=\"female\">Weiblich</option>";
						}
						if (salutationDefaultValue === 'male') {
							insertcode += "\n\t\t<option selected=\"selected\" value=\"male\">Männlich</option>";
						} else {
							insertcode += "\n\t\t<option value=\"male\">Männlich</option>";
						}
						if (salutationDefaultValue === 'family') {
							insertcode += "\n\t\t<option selected=\"selected\" value=\"family\">Familie</option>";
						} else {
							insertcode += "\n\t\t<option value=\"company\">Firma</option>";
						}

						insertcode += "\n\t</select>";
					}

					insertcode += "\n</fieldset>\n";

					//insert text
					editor.getDoc().setValue(editor.getDoc().getValue() + insertcode);

					//close modal
					self.parent.tb_remove();
				};
			})(i));
		}
	}
});