<?php
/* * **************************************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Harald Holzmann <harald@varioous.at>, varioous OG
 *
 *  Eyepin For Wordpress is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  any later version.
 *   
 *  Eyepin For Wordpress is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Eyepin For Wordpress. If not, see http://www.gnu.org/copyleft/gpl.html.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************************************** */

class VA_EY4WP_Admin_Form {

	public function display($id = FALSE) {
		$form = VA_EY4WP_Utility_Helper::getFormForId($id);
		if ($form != NULL) {
			$textareaValue = $form->form;
			$name = $form->name;
			$messageSent = $form->message_sent;
			$messageNotSent = $form->message_not_sent;
			$messageFieldError = $form->message_field_error;
            $messageFieldAlreadyExists = $form->message_field_already_exists;
			$optIn = $form->opt_in;
		} else {
			//set default values
			$textareaValue = '<fieldset>
	<label>Anrede</label>
	<select name="salutation" required>
		<option value="female">Frau</option>
		<option selected="selected" value="male">Herr</option>
		<option value="family">Familie</option>
	</select>
</fieldset>

<fieldset>
	<label>Vorname</label>
	<input type="text" name="firstname" placeholder="Vorname *" required>
</fieldset>

<fieldset>
	<label>Nachname</label>
	<input type="text" name="lastname" placeholder="Nachname *" required>
</fieldset>

<fieldset>
	<label>E-Mail Adresse</label>
	<input type="email" name="email" placeholder="E-Mail Adresse *" required>
</fieldset>';
			$name = "Kontaktformular";
			$messageSent = "Vielen Dank - Die Anmeldung zum Newsletter war erfolgreich!";
			$messageNotSent = "Bitte füllen Sie alle benötigten Felder aus.";
			$messageFieldError = "Die Anmeldung konnte leider nicht durchgeführt werden! Versuchen Sie es später erneut.";
			$optIn = "Ja";
		}
		?>
		<div class="wrap">
			<h1 class="page-title">
				<?php _e('Eyepin für Wordpress', VA_EY4WP_PLUGIN_NAME); ?> › 
				<? if ($form == NULL){ 
					_e('Neues Formular hinzufügen', VA_EY4WP_PLUGIN_NAME); 
				} else {
					_e('Formular bearbeiten', VA_EY4WP_PLUGIN_NAME); 
				} ?>
			</h1>
			<form method="post" action="<?php echo site_url(); ?>/wp-admin/admin.php?page=eyepin-for-wp-forms" id="va-ey4wp-admin-form">
				<?php
				wp_nonce_field('eyepin-for-wp-form-form');
				if ($form != NULL) {
					echo '<input type="hidden" name="wordpress-for-eypin-form-id" value="' . $form->id . '">';
				}
				?>
				<div id="poststuff">
					<div id="post-body" class="metabox-holder columns-2">
						<div id="post-body-content">
							<div id="titlediv">
								<div id="titlewrap">
									<label class="screen-reader-text" id="title-prompt-text" for="title"><?php _e('Titel hier eingeben', VA_EY4WP_PLUGIN_NAME) ?></label>
									<input type="text" name="form_name" value="<?php echo $name; ?>" size="30" id="title" spellcheck="true" autocomplete="off">
								</div>
							</div>
						</div>

						<div id="postbox-container-1" class="postbox-container">
							<div id="submitdiv" class="postbox">
								<h3><?php _e('Funktionen', VA_EY4WP_PLUGIN_NAME) ?> </h3>
								<div class="inside">
									<div class="submitbox" id="submitpost">
										<div id="minor-publishing-actions">
											<input type="submit" class="button-primary" name="wpcf7-save" value="Speichern">
										</div>
										<div id="misc-publishing-actions">
										</div>
									</div>

								</div>
							</div>
							<div id="settingsdiv" class="postbox">
								<h3><?php _e('Einstellungen', VA_EY4WP_PLUGIN_NAME) ?></h3>
								<div class="inside">
									<p><?php _e('Opt-In E-Mail wird durch Eyepin versendet', VA_EY4WP_PLUGIN_NAME) ?>:</p>
									<select id="eyepin-for-wp-optin-eyepin-mail" name="form-optin-eyepin">
										<option value="Ja" <?php if($optIn == 'Ja') { echo 'selected="selected"';} ?>><?php _e('Ja', VA_EY4WP_PLUGIN_NAME) ?></option>
										<option value="Nein" <?php if($optIn == 'Nein') { echo 'selected="selected"';} ?>><?php _e('Nein', VA_EY4WP_PLUGIN_NAME) ?></option>
									</select>
								</div>
							</div>
							<div id="infodiv" class="postbox">
								<h3><?php _e('Informationen', VA_EY4WP_PLUGIN_NAME) ?></h3>
								<div class="inside">
									<ul>
										<li><a target="_blank" href="http://www.eyepin.com/"><?php _e('Eyepin', VA_EY4WP_PLUGIN_NAME) ?></a></li>
										<li><a target="_blank" href="http://www.eyepin.com/de/kontakt/?no_cache=1/"><?php _e('Kontakt', VA_EY4WP_PLUGIN_NAME) ?></a></li>
									</ul>
								</div>
							</div>
						</div>

						<div id="postbox-container-2" class="postbox-container">
							<div id="contact-form-editor" class="ui-tabs ui-widget ui-widget-content ui-corner-all">
								<h2 class="nav-tab-wrapper wp-clearfix eyepin-for-pw-tab-header">
									<a id="eyepin-for-wp-tab-fields" href="#" class="nav-tab nav-tab-active"><?php _e('Felder', VA_EY4WP_PLUGIN_NAME) ?></a>
									<a id="eyepin-for-wp-tab-messages" href="#" class="nav-tab"><?php _e('Nachrichten', VA_EY4WP_PLUGIN_NAME) ?></a>
								</h2>
								<div class="eyepin-for-wp-fields" id="eyepin-for-wp-tabdiv-fields">
		<?php include(VA_EY4WP_PLUGIN_DIR . 'admin/pages/tabs/form-fields.php'); ?>
								</div>
								<div class="eyepin-for-wp-fields hidden" id="eyepin-for-wp-tabdiv-messages">
		<?php include(VA_EY4WP_PLUGIN_DIR . 'admin/pages/tabs/form-messages.php'); ?>
								</div>
							</div>
						</div>
					</div>
					<br class="clear">
				</div>
			</form>
		</div>
		<?php
	}

}
