<?php

/* * **************************************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Harald Holzmann <harald@varioous.at>, varioous OG
 *
 *  Eyepin For Wordpress is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  any later version.
 *   
 *  Eyepin For Wordpress is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Eyepin For Wordpress. If not, see http://www.gnu.org/copyleft/gpl.html.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************************************** */

class VA_EY4WP_Utility_Shortcodehandler
{

    public function display($id)
    {
        $form = VA_EY4WP_Utility_Helper::getFormForId($id);
        if ($form != NULL) {
            $fields = array('email', 'title', 'salutation', 'firstname', 'lastname', 'street', 'zip', 'city', 'country', 'phone', 'fax',
                'mobile', 'internet', 'company', 'function', 'attribute1', 'attribute2', 'attribute3', 'attribute4', 'attribute5',
                'attribute6', 'attribute7', 'attribute8', 'attribute9', 'attribute10', 'attribute11', 'attribute12', 'attribute13',
                'attribute14', 'attribute15', 'attribute16', 'attribute17', 'attribute18', 'attribute19', 'attribute20');
            if (count($_POST) > 0 && isset($_POST['send'])) {
                //handle form submit
                if (!isset($_POST['_eyepin_for_wp_nonce']) || !wp_verify_nonce($_POST['_eyepin_for_wp_nonce'], 'handle_eyepin_for_wp_form')) {
                    echo '<p class="error">' . $form->message_field_error . '</p>';
                    return;
                } else {

                    $values = array();
                    foreach ($fields as $field) {
                        $value = filter_input(INPUT_POST, $field);
                        if ($value != NULL) {
                            $values[$field] = $value;
                        }
                    }

                    $eyepinHelper = new VA_EY4WP_Utility_Eyepinhelper();
                    $submitResult = $eyepinHelper->submitAddress($values, $form);


                    if ($submitResult === 4108) {
                        //error
                        echo '<p class="error">' . $form->message_field_already_exists . '</p>';
                        return;
                    } else if ($submitResult) {
                        //success
                        echo '<p class="success">' . $form->message_sent . '</p>';
                        return;
                    } else {
                        //error
                        echo '<p class="error">' . $form->message_field_error . '</p>';
                        return;
                    }
                }
            } else {
                //display form
                echo "<form method='post' action=''>";
                echo wp_nonce_field('handle_eyepin_for_wp_form', '_eyepin_for_wp_nonce');
                echo $form->form;
                echo "<input type='submit' name='send' value='»'/>";
                echo "</form>";
            }
        } else {
            echo 'Das Formular existiert nicht!';
        }
    }

}
